DECLARE SUB ScreenParams (scrn%, screenwidth%, screenlength%, NP%)
DECLARE SUB DRAWPIC (scrn%)
DECLARE SUB VGAtoEPSON (scrn%, f$, flip%, border%)
DIM SHARED scrn%, screenwidth%, screenlength%
CLS : scrn% = 0
WHILE (scrn% < 7) OR (scrn% > 12)
  INPUT "Enter Screen Mode: (7,8,9,10,11,12)"; scrn%
WEND
SCREEN scrn%: REM **************** CALL DRAWPIC(scrn%)
FOR i = 1 TO 200: CIRCLE (RND(1) * 400, RND(1) * 400), RND(1) * 200, RND(1) * 15 + 1
NEXT
CALL VGAtoEPSON(scrn%, "LPT1", 0, 255)
END

SUB DRAWPIC (scrn%)
 EXIT SUB
 CALL ScreenParams(scrn%, screenwidth%, screenlength%, NumPlanes%)
 IF NumPlanes% = 2 THEN ci% = 0 ELSE ci% = 1
 xmax% = screenwidth%: ymax% = SreenLength%
 halfx% = xmax% / 2: halfy% = ymax% / 2
 x% = halfx%: c% = 1
 FOR y% = ymax% TO halfy% STEP -5
   deltax% = xmax% - x%: deltay% = ymax% - y%
   LINE (halfx%, y%)-(x%, halfy%), c%
   LINE (x%, ymax%)-(xmax%, y%), c% + ci%
   LINE (halfx%, deltay%)-(x%, halfy%), c% + 2 * ci%
   LINE (x%, 0)-(xmax%, deltay%), c% + 3 * ci%
   LINE (halfx% + 1, y%)-(deltax%, halfy%), c% + 4 * ci%
   LINE (deltax%, ymax%)-(0, y%), c% + 5 * ci%
   LINE (halfx%, deltay%)-(deltax%, halfy% + 1), c% + 6 * ci%
   LINE (deltax%, 0)-(0, deltay%), c% + 7 * ci%
   x% = x% + (((xmax% + 1) / (ymax% + 1)) * 5)
 NEXT y%
END SUB

SUB ScreenParams (scrn%, screenwidth%, screenlength%, NumPlanes%)
  NumPlanes% = 4: screenwidth% = 640: screenlength% = 480
  SELECT CASE scrn%
    CASE 7
     screenwidth% = 320: screenlength% = 200
    CASE 8
     screenlength% = 200
    CASE 9
     screenlength% = 350
    CASE 10
     NumPlanes% = 2: screenlength% = 350
    CASE 11
     NumPlanes% = 2
  END SELECT
PRINT "screenwidth:"; screenwidth%; "Screenlength:"; screenlength%
SLEEP 5
END SUB

SUB VGAtoEPSON (scrn%, fileN$, flip%, border%) STATIC
  OPEN fileN$ FOR BINARY AS 1
  WIDTH #1, 255
  esc$ = CHR$(27): crlf$ = CHR$(13) + CHR$(10)
  line$ = esc$ + "A" + CHR$(8)'Set Printer to 8/72 lpi
  PUT #1, , line$
  CALL ScreenParams(scrn%, screenwidth%, screenlength%, NumPlanes%)
  IF screenlength% < 480 THEN
    numbyte% = screenlength% * 2 + 16
    maxy% = screenlength% - 1
  ELSE
    numbyte% = 960: maxy% = 479
  END IF
  DEF SEG = &HA000
  BorderOffset% = (960 - numbyte%) / (2 * 8)
  IF screenlength% < 480 THEN
   line$ = SPACE$(BorderOffset%)
   PUT #1, , line$
   line$ = esc$ + "L" + MKI$(numbyte%)
   line$ = line$ + STRING$(numbyte%, border%) + crlf$
   PUT #1, , line$
  END IF
  colend% = (screenwidth% / 8) - 1
  FOR col% = 0 TO colend%
  IF screenlength% < 480 THEN
    line$ = SPACE$(BorderOffset%)
    PUT #1, , line$
  END IF
  line$ = esc$ + "L" + MKI$(numbyte%)
  PUT #1, , line$
  IF screenlength% < 480 THEN
    line$ = STRING$(8, border%)
    PUT #1, , line$
  END IF
  FOR row% = maxy% TO 0 STEP -1
   FOR plane% = 0 TO 1
     OUT &H3CE, 4: OUT &H3CF, plane%
     place& = row%
     place& = place& * (colend% + 1)
     place& = place& + col%
     mem% = PEEK(place&)
     IF NumPlanes% = 4 THEN
       OUT &H3CE, 4: OUT &H3CF, plane% + 2
       mem% = mem% OR PEEK(place&)
     END IF
     IF flip% <> 0 THEN mem% = 255 - mem%
     line$ = CHR$(mem%): PUT #1, , line$
   NEXT plane%
  NEXT row%
  line$ = crlf$
  IF screenlength% < 480 THEN
    line$ = STRING$(8, border%) + crlf$
  END IF
  PUT #1, , line$
  NEXT col%
  IF screenlength% < 480 THEN
    line$ = SPACE$(BorderOffset%)
    PUT #1, , line$
    line$ = esc$ + "L" + MKI$(numbyte%)
    line$ = line$ + STRING$(numbyte%, border%) + crlf$
    PUT #1, , line$
  END IF
  ResetPrn$ = esc$ + "@"
  PUT #1, , ResetPrn$
  line$ = CHR$(12): PUT #1, , line$
  CLOSE 1
END SUB


